#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI;
use acs;
#use LWP 5.64;
use LWP::Simple;
use obbuild;

&get_setup;
$q = CGI->new;

if ($q->param('fct') ne "")
	{
	acs::check_access($username, $password, $q->param('username'), $q->param('password'));
	print "Content-type: text/html\n\n"; 

	if ($q->param('fct') eq "web"){&prepare_web_build; exit;}
	if ($q->param('fct') eq "do_web_checking"){&do_web_checking; exit;}
	if ($q->param('fct') eq "catcheck"){&catcheck; exit;}
	}


if ($q->param('fct') eq ""){ &ssh_telnet_check; }



#############################################################################
sub catcheck
{

$ids = $q->param('ids');
$ids =~ s/ //g;

if ($ids eq "") { acs::problem_popup("You need to specify at least one category ID."); }

@all_ids = split (/,/,$ids);

foreach $item (@all_ids)
	{
	$sql_w = $sql_w . " (cid = '$item') OR";
	}
	$sql_w = substr($sql_w, 0, length($sql_w) - 2);

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT lnkid FROM links WHERE $sql_w";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

open (CIDF, "> $data_dir/cid.tmp");
	while ( @row = $sth->fetchrow() )
	{
	print CIDF  "$row[0]\n";
	}
close (CIDF);

########

$sth->finish;
$dbh->disconnect;


print <<END_OF_SWF;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/linkchecker2.cgi?fct=do_web_checking&nr=0&total=$rows">
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="96%" valign="top"><strong><font face="Arial" size="4">Checking Links... </font><font
    face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1">Please wait...</font></td>
  </tr>
</table>
<hr noshade size="1" color="#F2F2F2">
<p><font face="Verdana" size="1">Creating swap files...</font></p>
</body>
</html>

END_OF_SWF



}



sub do_web_checking
{

$cconf = acs::get_file_contents("$data_dir/crawler.cfg");  
($ver, $links_to_check_per_window) = split (/\n/, $cconf);

if ($links_to_check_per_window eq ""){$links_to_check_per_window = 20;}

$nr = $q->param('nr');
$total = $q->param('total');

if ($nr > $total) { &end_check; exit; }

#$links_to_check_per_window = 5;

$new_nr = $nr + $links_to_check_per_window;


print <<END_OF_SCR;
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/linkchecker2.cgi?fct=do_web_checking&nr=$new_nr&total=$total">
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="96%" valign="top"><strong><font face="Arial" size="4">Checking Links... </font><font
    face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1">Please wait...</font></td>
  </tr>
</table>
<hr noshade size="1" color="#F2F2F2">

<p><font face="Verdana" size="1">Checked <strong>$nr</strong> of <strong>$total</strong>
Links so far.. Please wait...</font></p>

END_OF_SCR

#<p><font face="Verdana" size="1">Creating swap files...</font></p>
#</body>
#</html>

$cntr = 0;
$fline_cntr = 0;
$end_fline_cntr = $nr + $links_to_check_per_window;

open (CIDF, "$data_dir/cid.tmp");
	while (defined($line=<CIDF>)) 
	{
		if (($fline_cntr > ($nr - 1)) and ($fline_cntr < $end_fline_cntr))
			{
			$line =~ s/\n//g;
			$ids_to_check = $ids_to_check . " (lnkid = '$line') OR";
			$cntr++;
			}
	$fline_cntr++;
	}
close (CIDF);

if ($ids_to_check ne "")
	{
	&check_web_broken_links;
	}

print "</body></html>";

}



sub end_check
{

print <<END_OC;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/add.gif"></td>
    <td width="95%" valign="top"><strong><font face="Arial" size="4" color="#000000">Check
    Complete</font><font face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1"><a href="$admin_url/admin11.cgi?fct=blinks">Manage
    Broken Links</a> | <a href="$admin_url/admin44.cgi">Broken Link Checker</a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#F2F2F2">
<p>&nbsp;</p>
</body>
</html>

END_OC


}


##############################


sub check_web_broken_links
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh2 = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

### BUILD SQL QUERY

$ids_to_check = substr($ids_to_check, 0, length($ids_to_check) - 2);

$sql = "SELECT lnkid,cid,url FROM links WHERE $ids_to_check";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

print "<font face=\"Verdana\" size=\"1\">";

	while ( @row = $sth->fetchrow() )
	{
	print "<b>Connecting:</b> $row[2]<br>";
	
	if (($row[2] eq "") or (lc($row[2]) eq "http://"))
	{
	$stat = "NOLINK";
	}
	else
	{
	($RE_code, $stat) = &check_url2(lc($row[2]));
	}
	
		if ($stat eq "OK")
			{
			print "<b>Success:</b> $RE_code : $row[2]<br><br>";
			}
			elsif ($stat eq "NOLINK")
			{
			print "<b>Skipped:</b> Listing has no URL<br><br>";
			}
			else
			{

			$RE_code1 = $RE_code;
			$RE_code1 =~ s/'/\\'/g; 
	
			$sql2 = "INSERT IGNORE INTO brokenlnks SET lnkid = '$row[0]', 
																	 cid = '$row[1]',
																	 lnkproblem = '$RE_code1'";
																	 
			$sth2 = $dbh->prepare($sql2);
			$sth2->execute;
			$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql2";} 

			print "<b>Failed:</b> $RE_code : $row[2]<br><br>";
			}
	}

print "</font>";

$sth->finish;
$dbh->disconnect;

if ($RE_code1 ne "")
	{
	$sth2->finish;
	}

$dbh2->disconnect;

}



#############################################################################

sub prepare_web_build
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT lnkid FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

open (CIDF, "> $data_dir/cid.tmp");
	while ( @row = $sth->fetchrow() )
	{
	print CIDF  "$row[0]\n";
	}
close (CIDF);

########

$sth->finish;
$dbh->disconnect;


print <<END_OF_SWF;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/linkchecker2.cgi?fct=do_web_checking&nr=0&total=$rows">
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="96%" valign="top"><strong><font face="Arial" size="4">Checking Links... </font><font
    face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1">Please wait...</font></td>
  </tr>
</table>
<hr noshade size="1" color="#F2F2F2">
<p><font face="Verdana" size="1">Creating swap files...</font></p>
</body>
</html>

END_OF_SWF

}



##################################################################################

sub ssh_telnet_check
{

if ($ARGV[0] ne "0")
	{
	$ARGV[0] =~ s/\n//g;
	$ARGV[0] =~ s/ //g;
	
	@all_ids = split (/,/,$ARGV[0]);
	
	foreach $item (@all_ids)
		{
		if ($item ne "")
			{
			$sql_w = $sql_w . " (cid = '$item') OR";
			}
		}
		
	$sql_w = substr($sql_w, 0, length($sql_w) - 2);
	
	$sql_w = "WHERE $sql_w";
	}
	

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh2 = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT lnkid,cid,url FROM links $sql_w";
$sth = $dbh->prepare($sql);
$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

while ( @row = $sth->fetchrow() )
	{
	
	   if ($row[2] ne "")
		{
		print "Connecting: $row[2]\n";


			if (($row[2] eq "") or (lc($row[2]) eq "http://"))
			{
			$stat = "NOLINK";
			}
		else
		{
		($RE_code, $stat) = &check_url2(lc($row[2]));
		}
	
	######
	
	if ($stat eq "OK")
		{
		print "Success: $RE_code : $row[2]\n\n";
		}
		elsif ($stat eq "NOLINK")
		{
		print "Skipped: Listing has no URL\n\n";
		}
		else
		{
		$something = "something";
		
		$RE_code1 = $RE_code;
		$RE_code1 =~ s/'/\\'/g; 


		$sql2 = "INSERT IGNORE INTO brokenlnks SET lnkid = '$row[0]', 
																 cid = '$row[1]',
																 lnkproblem = '$RE_code1'";
																 
		#print "\n\n\n$sql2\n\n\n"; exit;
		$sth2 = $dbh->prepare($sql2);
		$sth2->execute;
		#$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql2";} 

		print "Failed: $RE_code : $row[2]\n\n";
		}
	}
	else
	{
	print "Skipped: Listing has no URL\n\n";
	}

	}
  
$sth->finish;
$dbh->disconnect;

if ($something ne "")
	{
	$sth2->finish;
	}
$dbh2->disconnect;

print "Link Check Complete - $rows Links Checked\n\n";

}




sub check_url
{
my ($the_url) = @_;

my $browser = LWP::UserAgent->new;
$browser->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); 
my $response = $browser->get($the_url);

$wresponse = $response->status_line; 

if ($response->is_success)
	{
	$lok = "OK";
	}
	else
	{
	$lok = "";
	}

return ($wresponse, $lok);
}




sub check_url2
{
my ($the_url) = @_;


$response{'404'} = "File not found";
$response{'300'} = "Multiple Choices?";
$response{'301'} = "Moved Permanently";
$response{'302'} = "Moved Temporarily";
$response{'303'} = "See Other";
$response{'304'} = "Not Modified";
$response{'305'} = "Use Proxy";
$response{'400'} = "Bad Request - Request could not be understood by the server";
$response{'401'} = "Unauthorized - The request requires user authentication.";
$response{'403'} = "Forbidden - Access not allowed";
$response{'405'} = "Method Not Allowed";
$response{'406'} = "Not Acceptable";
$response{'407'} = "Proxy Authentication Required";
$response{'408'} = "Request Timeout";
$response{'409'} = "Conflict";
$response{'410'} = "Gone - The requested resource is no longer available";
$response{'411'} = "Length Required";
$response{'412'} = "recondition Failed";
$response{'413'} = "Request Entity Too Large";
$response{'414'} = "Request-URI Too Long";
$response{'415'} = "Unsupported Media Type";

##################

$statuscode = getstore($the_url, "$data_dir/checker.tmp");

if ($statuscode == 200)
	{
	$lok = "OK";
	$wresponse = "200 - OK";
	}
	else
	{
	$lok = "";
   $http_rs = $response{$statuscode};
   if ($http_rs > 499) 
   	{
   	$wresponse = "$statuscode - Could not connect."; 
   	}
   	elsif ($http_rs eq "") 
   	{ 
   	$wresponse = "$statuscode - Could not connect."; 
   	}
   	else
   	{
   	$wresponse = "$statuscode - $http_rs"; 
   	}
	}

return ($wresponse, $lok);
}


#my $req = new HTTP::Request GET => 'http://mycorp.com/';
#my $res = $ua->request($req);



####################################################################################


#my $browser = LWP::UserAgent->new; 



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################



sub get_env
{
if ($ENV{'QUERY_STRING'} ne "") {
								$temp = $ENV{'QUERY_STRING'};
								}
								else
								{
								read(STDIN, $temp, $ENV{'CONTENT_LENGTH'});
								}

@pairs=split(/&/,$temp);
foreach $item(@pairs){
	($key,$content)=split (/=/,$item,2);
	$content=~tr/+/ /;
	$content=~ s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;}

}
 